=== tools/scripts/Makefile ===

all:
	./configure
