=== debian/changelog ===
vdrift (20141020-1~mx17+1) mx; urgency=medium

  * Repackaged for MX 17.
  * Modified control & rules to use gcc-4.9
  * Enabled libglew-dev

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 14 Apr 2018 19:56:28 -0700

vdrift (20141020-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Wed, 19 Nov 2014 20:24:48 +0100

vdrift (20140926-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Tue, 30 Sep 2014 20:11:22 +0200

vdrift (20140922-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Thu, 25 Sep 2014 21:46:11 +0200

vdrift (20140811-1~getdeb2) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Wed, 17 Sep 2014 21:32:46 +0200

vdrift (20140811-1~getdeb1) trusty; urgency=medium

  * New upstream version

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sun, 31 Aug 2014 21:32:46 +0200

vdrift (20120722-1~getdeb6~trusty) trusty; urgency=low

  * Rebuild for trusty

 -- Christoph Korn <christoph.korn@getdeb.net>  Sun, 06 Apr 2014 20:40:05 +0200

vdrift (20120722-1~getdeb5~raring) raring; urgency=low

  * Rebuild for raring.

 -- Christoph Korn <christoph.korn@getdeb.net>  Wed, 08 May 2013 22:26:40 +0200

vdrift (20120722-1~getdeb4~quantal) quantal; urgency=low

  * Rebuild against new bullet version.

 -- Christoph Korn <christoph.korn@getdeb.net>  Fri, 22 Mar 2013 20:08:59 +0100

vdrift (20120722-1~getdeb2) quantal; urgency=low

  * Rebuild for quantal

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 20 Oct 2012 15:19:13 +0200

vdrift (20120722-1~getdeb1) precise; urgency=low

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Tue, 24 Jul 2012 19:59:20 +0200

vdrift (20111022-1~getdeb2~precise) precise; urgency=low

  * Rebuild for precise

 -- Christoph Korn <christoph.korn@getdeb.net>  Fri, 06 Apr 2012 14:28:09 +0200

vdrift (20111022-1~getdeb1) oneiric; urgency=low

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Tue, 15 Nov 2011 17:03:33 +0100

vdrift (20100630-1~getdeb2) lucid; urgency=low

  * debian/patches/opengl.patch: Replace glGenerateMipmap
    with glGenerateMipmapEXT (LP: #824472)

 -- Christoph Korn <christoph.korn@getdeb.net>  Thu, 11 Aug 2011 19:18:14 +0200

vdrift (20100630-1~getdeb1) lucid; urgency=low

  * New upstream version (LP: #606096)

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 24 Jul 2010 22:12:47 +0200

vdrift (20090615-1~getdeb1) jaunty; urgency=low

  * Initial release

 -- Christoph Korn <c_korn@gmx.de>  Mon, 10 Aug 2009 14:23:11 +0200
