=== debian/control ===
Source: vdrift
Section: games
Priority: optional
Maintainer: Christoph Korn <c_korn@gmx.de>
Build-Depends: debhelper (>= 9),
               gcc-4.9,
               g++-4.9,
               cpp-4.9,
               scons,
               lsb-release,
               libsdl2-dev,
               libsdl2-image-dev,
               libvorbis-dev,
               libbullet-dev,
               libcurl4-gnutls-dev
Standards-Version: 3.9.5
Homepage: http://vdrift.net/

Package: vdrift
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         vdrift-data (= ${source:Version})
Description: Cross-platform, open source driving simulation
 VDrift is a cross-platform, open source driving
 simulation made with drift racing in mind.

Package: vdrift-data
Architecture: all
Depends: ${misc:Depends}
Description: Cross-platform, open source driving simulation (data files)
 VDrift is a cross-platform, open source driving
 simulation made with drift racing in mind.
 .
 This package contains the data files.
